/**
 *  \file IMP/container/DynamicListPairContainer.h
 *  \brief Store a list of ParticlePairsTemp
 *
 *  WARNING This file was generated from DynamicListPairContainer.h
 *  in /builddir/build/BUILD/imp-2.1.1/imp/tools/build/container_templates/container
 *  by tools/maintenance/setup_containers.py.
 *
 *  Copyright 2007-2013 IMP Inventors. All rights reserved.
 */

#ifndef IMPCONTAINER_DYNAMIC_LIST_PAIR_CONTAINER_H
#define IMPCONTAINER_DYNAMIC_LIST_PAIR_CONTAINER_H

#include <IMP/container/container_config.h>
#include <IMP/base/object_macros.h>
#include <IMP/kernel/internal/InternalDynamicListPairContainer.h>

IMPCONTAINER_BEGIN_NAMESPACE

//! Store a ParticleIndexPairs
/** In contrast to ListPairContainer, this list is designed to act
    as the output of a ScoreState or another container. The key difference
    is that it uses the passed Container to define the list of all
    possible contents of the container.
 */
class IMPCONTAINEREXPORT DynamicListPairContainer :
#if defined(IMP_DOXYGEN) || defined(SWIG)
    public PairContainer
#else
    public IMP::kernel::internal::InternalDynamicListPairContainer
#endif
    {
  typedef IMP::kernel::internal::InternalDynamicListPairContainer P;

 public:
  DynamicListPairContainer(Container *m, std::string name =
                                                  "ListPairContainer %1%");

  /** @name Methods to control the contained objects

      This container stores a list of Pair objects. To manipulate
      the list use these methods.
   */
  /**@{*/
  void add_particle_pair(const ParticlePair& vt);
  void add_particle_pairs(const ParticlePairsTemp &c);
  void set_particle_pairs(ParticlePairsTemp c);
  void clear_particle_pairs();
/**@}*/
#ifdef SWIG
  ParticleIndexPairs get_indexes() const;
  ParticleIndexPairs get_range_indexes() const;
  void do_before_evaluate();
  kernel::ModelObjectsTemp do_get_inputs() const;
  void do_apply(const PairModifier *sm) const;
  kernel::ParticleIndexes get_all_possible_indexes() const;
#endif
  IMP_OBJECT_METHODS(DynamicListPairContainer);
};

IMP_OBJECTS(DynamicListPairContainer, DynamicListPairContainers);

IMPCONTAINER_END_NAMESPACE

#endif /* IMPCONTAINER_DYNAMIC_LIST_PAIR_CONTAINER_H */
