/**
 *  \file IMP/container/DynamicListSingletonContainer.h
 *  \brief Store a list of ParticlesTemp
 *
 *  WARNING This file was generated from DynamicListSingletonContainer.h
 *  in /builddir/build/BUILD/imp-2.1.1/imp/tools/build/container_templates/container
 *  by tools/maintenance/setup_containers.py.
 *
 *  Copyright 2007-2013 IMP Inventors. All rights reserved.
 */

#ifndef IMPCONTAINER_DYNAMIC_LIST_SINGLETON_CONTAINER_H
#define IMPCONTAINER_DYNAMIC_LIST_SINGLETON_CONTAINER_H

#include <IMP/container/container_config.h>
#include <IMP/base/object_macros.h>
#include <IMP/kernel/internal/InternalDynamicListSingletonContainer.h>

IMPCONTAINER_BEGIN_NAMESPACE

//! Store a ParticleIndexes
/** In contrast to ListSingletonContainer, this list is designed to act
    as the output of a ScoreState or another container. The key difference
    is that it uses the passed Container to define the list of all
    possible contents of the container.
 */
class IMPCONTAINEREXPORT DynamicListSingletonContainer :
#if defined(IMP_DOXYGEN) || defined(SWIG)
    public SingletonContainer
#else
    public IMP::kernel::internal::InternalDynamicListSingletonContainer
#endif
    {
  typedef IMP::kernel::internal::InternalDynamicListSingletonContainer P;

 public:
  DynamicListSingletonContainer(Container *m, std::string name =
                                                  "ListSingletonContainer %1%");

  /** @name Methods to control the contained objects

      This container stores a list of Singleton objects. To manipulate
      the list use these methods.
   */
  /**@{*/
  void add_particle(Particle* vt);
  void add_particles(const ParticlesTemp &c);
  void set_particles(ParticlesTemp c);
  void clear_particles();
/**@}*/
#ifdef SWIG
  ParticleIndexes get_indexes() const;
  ParticleIndexes get_range_indexes() const;
  void do_before_evaluate();
  kernel::ModelObjectsTemp do_get_inputs() const;
  void do_apply(const SingletonModifier *sm) const;
  kernel::ParticleIndexes get_all_possible_indexes() const;
#endif
  IMP_OBJECT_METHODS(DynamicListSingletonContainer);
};

IMP_OBJECTS(DynamicListSingletonContainer, DynamicListSingletonContainers);

IMPCONTAINER_END_NAMESPACE

#endif /* IMPCONTAINER_DYNAMIC_LIST_SINGLETON_CONTAINER_H */
